/*
 Do not modify, auto-generated by model_gen.tcl

 Copyright 2019 Alain Dargelas

 Licensed under the Apache License, Version 2.0 (the "License");
 you may not use this file except in compliance with the License.
 You may obtain a copy of the License at

 http://www.apache.org/licenses/LICENSE-2.0

 Unless required by applicable law or agreed to in writing, software
 distributed under the License is distributed on an "AS IS" BASIS,
 WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 See the License for the specific language governing permissions and
 limitations under the License.
 */

/*
 * File:   clocking_io_decl.h
 * Author:
 *
 * Created on December 14, 2019, 10:03 PM
 */

#ifndef UHDM_CLOCKING_IO_DECL_H
#define UHDM_CLOCKING_IO_DECL_H

#include "SymbolFactory.h"
#include "BaseClass.h"
#include "containers.h"
#include "uhdm.h"

namespace UHDM {

  class clocking_io_decl : public BaseClass {
  public:
    // Implicit constructor used to initialize all members,
    // comment: clocking_io_decl();
    virtual ~clocking_io_decl() final {}
    
    virtual const BaseClass* VpiParent() const final { return vpiParent_; }

    virtual bool VpiParent(BaseClass* data) final { vpiParent_ = data; if (data) uhdmParentType_ = data->UhdmType(); return true;}

    virtual unsigned int UhdmParentType() const final { return uhdmParentType_; }

    virtual bool UhdmParentType(unsigned int data) final { uhdmParentType_ = data; return true;}

    virtual bool VpiFile(const std::string& data) final;

    virtual const std::string& VpiFile() const final;

    unsigned int UhdmId() const { return uhdmId_; }

    bool UhdmId(unsigned int data) { uhdmId_ = data; return true;}

    clocking_io_decl* DeepClone(Serializer* serializer, ElaboratorListener* elab_listener, BaseClass* parent) const override;

    int VpiDirection() const { return vpiDirection_; }

    bool VpiDirection(int data) { vpiDirection_ = data; return true;}

    bool VpiName(const std::string& data);

    const std::string& VpiName() const;

    int VpiInputEdge() const { return vpiInputEdge_; }

    bool VpiInputEdge(int data) { vpiInputEdge_ = data; return true;}

    int VpiOutputEdge() const { return vpiOutputEdge_; }

    bool VpiOutputEdge(int data) { vpiOutputEdge_ = data; return true;}

    const delay_control* Input_skew() const { return input_skew_; }

    bool Input_skew(delay_control* data) { input_skew_ = data; return true;}

    const delay_control* Output_skew() const { return output_skew_; }

    bool Output_skew(delay_control* data) { output_skew_ = data; return true;}

    const any* Expr() const { return expr_; }

    bool Expr(any* data) {if (!nets_vars_ref_obj_groupGroupCompliant(data)) return false; expr_ = data; return true;}

    unsigned int VpiType() const final { return vpiClockingIODecl; }

   virtual  UHDM_OBJECT_TYPE UhdmType() const final { return uhdmclocking_io_decl; }   
  private:
    
    BaseClass* vpiParent_ = nullptr;

    unsigned int uhdmParentType_ = 0;

    SymbolFactory::ID vpiFile_ = 0;

    unsigned int uhdmId_ = 0;

    int vpiDirection_ = 0;

    SymbolFactory::ID vpiName_ = 0;

    int vpiInputEdge_ = 0;

    int vpiOutputEdge_ = 0;

    delay_control* input_skew_ = nullptr;

    delay_control* output_skew_ = nullptr;

    any* expr_ = nullptr;

  };

  
  class clocking_io_declFactory {
  friend Serializer;
  public:
  clocking_io_decl* Make() {
    clocking_io_decl* obj = new clocking_io_decl();
    objects_.push_back(obj);
    return obj;
  }
  private:
    std::vector<clocking_io_decl*> objects_;
  };
  
  
  class VectorOfclocking_io_declFactory {
  friend Serializer;
  public:
  std::vector<clocking_io_decl*>* Make() {
    std::vector<clocking_io_decl*>* obj = new std::vector<clocking_io_decl*>();
    objects_.push_back(obj);
    return obj;
  }
  private:
  std::vector<std::vector<clocking_io_decl*>*> objects_;
  };

};

#endif
