/*
 Do not modify, auto-generated by model_gen.tcl

 Copyright 2019 Alain Dargelas

 Licensed under the Apache License, Version 2.0 (the "License");
 you may not use this file except in compliance with the License.
 You may obtain a copy of the License at

 http://www.apache.org/licenses/LICENSE-2.0

 Unless required by applicable law or agreed to in writing, software
 distributed under the License is distributed on an "AS IS" BASIS,
 WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 See the License for the specific language governing permissions and
 limitations under the License.
 */

/*
 * File:   tagged_pattern.h
 * Author:
 *
 * Created on December 14, 2019, 10:03 PM
 */

#ifndef UHDM_TAGGED_PATTERN_H
#define UHDM_TAGGED_PATTERN_H

#include "SymbolFactory.h"
#include "BaseClass.h"
#include "containers.h"
#include "uhdm.h"

namespace UHDM {

  class tagged_pattern : public BaseClass {
  public:
    // Implicit constructor used to initialize all members,
    // comment: tagged_pattern();
    virtual ~tagged_pattern() final {}
    
    virtual const BaseClass* VpiParent() const final { return vpiParent_; }

    virtual bool VpiParent(BaseClass* data) final { vpiParent_ = data; if (data) uhdmParentType_ = data->UhdmType(); return true;}

    virtual unsigned int UhdmParentType() const final { return uhdmParentType_; }

    virtual bool UhdmParentType(unsigned int data) final { uhdmParentType_ = data; return true;}

    virtual bool VpiFile(const std::string& data) final;

    virtual const std::string& VpiFile() const final;

    unsigned int UhdmId() const { return uhdmId_; }

    bool UhdmId(unsigned int data) { uhdmId_ = data; return true;}

    tagged_pattern* DeepClone(Serializer* serializer, ElaboratorListener* elab_listener, BaseClass* parent) const override;

    bool VpiName(const std::string& data);

    const std::string& VpiName() const;

    const typespec* Typespec() const { return typespec_; }

    bool Typespec(typespec* data) { typespec_ = data; return true;}

    const any* Pattern() const { return pattern_; }

    bool Pattern(any* data) {if (!patternGroupCompliant(data)) return false; pattern_ = data; return true;}

    unsigned int VpiType() const final { return vpiTaggedPattern; }

   virtual  UHDM_OBJECT_TYPE UhdmType() const final { return uhdmtagged_pattern; }   
  private:
    
    BaseClass* vpiParent_ = nullptr;

    unsigned int uhdmParentType_ = 0;

    SymbolFactory::ID vpiFile_ = 0;

    unsigned int uhdmId_ = 0;

    SymbolFactory::ID vpiName_ = 0;

    typespec* typespec_ = nullptr;

    any* pattern_ = nullptr;

  };

  
  class tagged_patternFactory {
  friend Serializer;
  public:
  tagged_pattern* Make() {
    tagged_pattern* obj = new tagged_pattern();
    objects_.push_back(obj);
    return obj;
  }
  private:
    std::vector<tagged_pattern*> objects_;
  };
  
  
  class VectorOftagged_patternFactory {
  friend Serializer;
  public:
  std::vector<tagged_pattern*>* Make() {
    std::vector<tagged_pattern*>* obj = new std::vector<tagged_pattern*>();
    objects_.push_back(obj);
    return obj;
  }
  private:
  std::vector<std::vector<tagged_pattern*>*> objects_;
  };

};

#endif
